set ns [new Simulator]

set rate1  200000
set cir1  200000
set cbs1    30000

set rate2  200000
set cir2  200000
set cbs2    30000

set cir3  200000
set cbs3    30000

set cir4  200000
set cbs4    30000

set cir5  200000
set cbs5    30000

set cir6  200000
set cbs6    30000

set cir7  200000
set cbs7    30000

set cir8  200000
set cbs8    30000

set cir9  200000
set cbs9    30000

set cir10  200000
set cbs10    30000

set testTime 50
set packetSize 1000

# Open a file for writing the trace data
set trace_all [open out.all w]
set trace_wnd [open out.wnd w]

# Trace all events for post processing with animator (nam) or with any
# other software
$ns trace-all $trace_all 

# Record some variables from TCP stacks
proc record {} {
    global ns tcp3 tcp4 tcp5 tcp6 tcp7 tcp8 tcp9 tcp10 trace_wnd maxwnd
    
    # Sampling interval
    set time 0.01


    # WINDOW FOR TCP3

    # Read congestion window of tcp3
    set curr_cwnd [$tcp3 set cwnd_] 
  
    # Compare the value to maxwnd
    if {$curr_cwnd < $maxwnd} {
	set curr_wnd3 $curr_cwnd
    } else {
	set curr_wnd3 $maxwnd
    }

    # WINDOW FOR TCP4

    # Read congestion window of tcp4
    set curr_cwnd [$tcp4 set cwnd_] 
  
    # Compare the value to maxwnd
    if {$curr_cwnd < $maxwnd} {
	set curr_wnd4 $curr_cwnd
    } else {
	set curr_wnd4 $maxwnd
    }

    # WINDOW FOR TCP5

    # Read congestion window of tcp5
    set curr_cwnd [$tcp5 set cwnd_] 
  
    # Compare the value to maxwnd
    if {$curr_cwnd < $maxwnd} {
	set curr_wnd5 $curr_cwnd
    } else {
	set curr_wnd5 $maxwnd
    }

    # WINDOW FOR TCP6

    # Read congestion window of tcp6
    set curr_cwnd [$tcp6 set cwnd_] 
  
    # Compare the value to maxwnd
    if {$curr_cwnd < $maxwnd} {
	set curr_wnd6 $curr_cwnd
    } else {
	set curr_wnd6 $maxwnd
    }

    # WINDOW FOR TCP7

    # Read congestion window of tcp7
    set curr_cwnd [$tcp7 set cwnd_] 
  
    # Compare the value to maxwnd
    if {$curr_cwnd < $maxwnd} {
	set curr_wnd7 $curr_cwnd
    } else {
	set curr_wnd7 $maxwnd
    }

    # WINDOW FOR TCP8

    # Read congestion window of tcp8
    set curr_cwnd [$tcp8 set cwnd_] 
  
    # Compare the value to maxwnd
    if {$curr_cwnd < $maxwnd} {
	set curr_wnd8 $curr_cwnd
    } else {
	set curr_wnd8 $maxwnd
    }


    # WINDOW FOR TCP9

    # Read congestion window of tcp2
    set curr_cwnd [$tcp9 set cwnd_] 
  
    # Compare the value to maxwnd
    if {$curr_cwnd < $maxwnd} {
	set curr_wnd9 $curr_cwnd
    } else {
	set curr_wnd9 $maxwnd
    }


    # WINDOW FOR TCP10

    # Read congestion window of tcp1
    set curr_cwnd [$tcp10 set cwnd_] 

    # Compare the values to maxwnd to decide actual sending window
    if {$curr_cwnd < $maxwnd} {    
	set curr_wnd10 $curr_cwnd
    } else {
	set curr_wnd10 $maxwnd
    }

    #Calcultate LINK window
    set link_wnd [expr $curr_wnd3+$curr_wnd4+$curr_wnd5+$curr_wnd6+$curr_wnd7+$curr_wnd8+$curr_wnd9+$curr_wnd10]

    #Get the current time
    set now [$ns now]

    #Write the variables of interest vs. time
    puts $trace_wnd "$now $curr_wnd3 $curr_wnd4 $curr_wnd5 $curr_wnd6 $curr_wnd7 $curr_wnd8 $curr_wnd9 $curr_wnd10"
    
    #Re-schedule the procedure
    $ns at [expr $now+$time] "record"
}





# Set up the network topology shown at the top of this file:
set s1 [$ns node]
set s2 [$ns node]
set s3 [$ns node]
set s4 [$ns node]
set s5 [$ns node]
set s6 [$ns node]
set s7 [$ns node]
set s8 [$ns node]
set s9 [$ns node]
set s10 [$ns node]
set e1 [$ns node]
set e2 [$ns node]
set dest [$ns node]

$ns duplex-link $s1 $e1 10Mb 5ms DropTail
$ns duplex-link $s2 $e1 10Mb 5ms DropTail
$ns duplex-link $s3 $e1 10Mb 5ms DropTail
$ns duplex-link $s4 $e1 10Mb 5ms DropTail
$ns duplex-link $s5 $e1 10Mb 5ms DropTail
$ns duplex-link $s6 $e1 10Mb 5ms DropTail
$ns duplex-link $s7 $e1 10Mb 5ms DropTail
$ns duplex-link $s8 $e1 10Mb 5ms DropTail
$ns duplex-link $s9 $e1 10Mb 5ms DropTail
$ns duplex-link $s10 $e1 10Mb 5ms DropTail

$ns simplex-link $e1 $e2 2Mb 20ms dsRED/edge
$ns simplex-link $e2 $e1 2Mb 20ms dsRED/edge

$ns duplex-link $e2 $dest 10Mb 5ms DropTail


$ns duplex-link-op $e1 $e2 orient right
$ns duplex-link-op $e2 $dest orient right


set qE1E2 [[$ns link $e1 $e2] queue]
set qE2E1 [[$ns link $e2 $e1] queue]


# Set DS RED parameters from Edge1 to Core:
$qE1E2 meanPktSize $packetSize
$qE1E2 setNumPrec 2
$qE1E2 set qlen 60

$qE1E2 addPolicyEntry [$s1 id] [$dest id] TokenBucket 10 $cir1 $cbs1
$qE1E2 addPolicyEntry [$s2 id] [$dest id] TokenBucket 10 $cir2 $cbs2
$qE1E2 addPolicyEntry [$s3 id] [$dest id] TokenBucket 10 $cir3 $cbs3
$qE1E2 addPolicyEntry [$s4 id] [$dest id] TokenBucket 10 $cir4 $cbs4
$qE1E2 addPolicyEntry [$s5 id] [$dest id] TokenBucket 10 $cir5 $cbs5
$qE1E2 addPolicyEntry [$s6 id] [$dest id] TokenBucket 10 $cir6 $cbs6
$qE1E2 addPolicyEntry [$s7 id] [$dest id] TokenBucket 10 $cir7 $cbs7
$qE1E2 addPolicyEntry [$s8 id] [$dest id] TokenBucket 10 $cir8 $cbs8
$qE1E2 addPolicyEntry [$s9 id] [$dest id] TokenBucket 10 $cir9 $cbs9
$qE1E2 addPolicyEntry [$s10 id] [$dest id] TokenBucket 10 $cir10 $cbs10
$qE1E2 addPolicerEntry TokenBucket 10 11
$qE1E2 addPHBEntry 10 0 0
$qE1E2 addPHBEntry 11 0 1
$qE1E2 configQ 0 1 0 0 1 

# These setting are for RED
$qE1E2 configQ 0 0 10 40 0.05 

# These settings emulate TailDrop
# $qE1E2 configQ 0 0 60 60 1


# Set DS RED parameters from Edge2 to Core:fg

$qE2E1 meanPktSize $packetSize
$qE2E1 setNumPrec 2
$qE2E1 set qlen 60

$qE2E1 addPolicyEntry [$dest id] [$s1 id] TokenBucket 10 $cir1 $cbs1
$qE2E1 addPolicyEntry [$dest id] [$s2 id] TokenBucket 10 $cir2 $cbs2
$qE2E1 addPolicyEntry [$dest id] [$s3 id] TokenBucket 10 $cir3 $cbs3
$qE2E1 addPolicyEntry [$dest id] [$s4 id] TokenBucket 10 $cir4 $cbs4
$qE2E1 addPolicyEntry [$dest id] [$s5 id] TokenBucket 10 $cir5 $cbs5
$qE2E1 addPolicyEntry [$dest id] [$s6 id] TokenBucket 10 $cir6 $cbs6
$qE2E1 addPolicyEntry [$dest id] [$s7 id] TokenBucket 10 $cir7 $cbs7
$qE2E1 addPolicyEntry [$dest id] [$s8 id] TokenBucket 10 $cir8 $cbs8
$qE2E1 addPolicyEntry [$dest id] [$s9 id] TokenBucket 10 $cir9 $cbs9
$qE2E1 addPolicyEntry [$dest id] [$s10 id] TokenBucket 10 $cir10 $cbs10
$qE2E1 addPolicerEntry TokenBucket 10 11
$qE2E1 addPHBEntry 10 0 0
$qE2E1 addPHBEntry 11 0 1
$qE2E1 configQ 0 1 0 0 1 


# These setting are for RED
$qE2E1 configQ 0 0 10 40 0.05 

# These settings emulate TailDrop
# $qE2E1 configQ 0 0 60 60 1


# DEFINING CLIENTS:
# General parameters
set initialtimeout 5
set rto 100
set syn false
set jacobsonrtt false
set karnrtt true
set expbackoff true

set maxwnd 65 
set exponinc false
set additiveinc true
set slowstart true
set fastrtx true



set udp1 [new Agent/UDP]
$ns attach-agent $s1 $udp1
set cbr1 [new Application/Traffic/CBR]
$cbr1 attach-agent $udp1
$cbr1 set packet_size_ $packetSize
$udp1 set packetSize_ $packetSize
$cbr1 set rate_ $rate1
set null1 [new Agent/Null]
$ns attach-agent $dest $null1
$ns connect $udp1 $null1

set udp2 [new Agent/UDP]
$ns attach-agent $s2 $udp2
set cbr2 [new Application/Traffic/CBR]
$cbr2 attach-agent $udp2
$cbr2 set packet_size_ $packetSize
$udp2 set packetSize_ $packetSize
$cbr2 set rate_ $rate2
set null2 [new Agent/Null]
$ns attach-agent $dest $null2
$ns connect $udp2 $null2


set tcp3 [new Agent/TCP/RFC793edu]
$ns attach-agent $s3 $tcp3
$tcp3 set window_ $maxwnd
$tcp3 set rtxcur_init_ $initialtimeout
$tcp3 set add793jacobsonrtt_ $jacobsonrtt
$tcp3 set add793karnrtt_ $karnrtt
$tcp3 set add793rto_ $rto
$tcp3 set add793syn_ $syn
$tcp3 set add793expbackoff_ $expbackoff
$tcp3 set add793fastrtx_ $fastrtx
$tcp3 set add793slowstart_ $slowstart
$tcp3 set add793additiveinc_ $additiveinc
$tcp3 set add793exponinc_ $exponinc

$ns at 0.001 "$tcp3 set ssthresh_ 1"

set sink3 [new Agent/TCPSink]
$ns attach-agent $dest $sink3
$ns connect $tcp3 $sink3

set ftp3 [new Application/FTP]
$ftp3 attach-agent $tcp3



set tcp4 [new Agent/TCP/RFC793edu]
$ns attach-agent $s4 $tcp4
$tcp4 set window_ $maxwnd
$tcp4 set rtxcur_init_ $initialtimeout
$tcp4 set add793jacobsonrtt_ $jacobsonrtt
$tcp4 set add793karnrtt_ $karnrtt
$tcp4 set add793rto_ $rto
$tcp4 set add793syn_ $syn
$tcp4 set add793expbackoff_ $expbackoff
$tcp4 set add793fastrtx_ $fastrtx
$tcp4 set add793slowstart_ $slowstart
$tcp4 set add793additiveinc_ $additiveinc
$tcp4 set add793exponinc_ $exponinc

$ns at 0.001 "$tcp4 set ssthresh_ 1"

set sink4 [new Agent/TCPSink]
$ns attach-agent $dest $sink4
$ns connect $tcp4 $sink4

set ftp4 [new Application/FTP]
$ftp4 attach-agent $tcp4


set tcp5 [new Agent/TCP/RFC793edu]
$ns attach-agent $s5 $tcp5
$tcp5 set window_ $maxwnd
$tcp5 set rtxcur_init_ $initialtimeout
$tcp5 set add793jacobsonrtt_ $jacobsonrtt
$tcp5 set add793karnrtt_ $karnrtt
$tcp5 set add793rto_ $rto
$tcp5 set add793syn_ $syn
$tcp5 set add793expbackoff_ $expbackoff
$tcp5 set add793fastrtx_ $fastrtx
$tcp5 set add793slowstart_ $slowstart
$tcp5 set add793additiveinc_ $additiveinc
$tcp5 set add793exponinc_ $exponinc

$ns at 0.001 "$tcp5 set ssthresh_ 1"

set sink5 [new Agent/TCPSink]
$ns attach-agent $dest $sink5
$ns connect $tcp5 $sink5

set ftp5 [new Application/FTP]
$ftp5 attach-agent $tcp5


set tcp6 [new Agent/TCP/RFC793edu]
$ns attach-agent $s6 $tcp6
$tcp6 set window_ $maxwnd
$tcp6 set rtxcur_init_ $initialtimeout
$tcp6 set add793jacobsonrtt_ $jacobsonrtt
$tcp6 set add793karnrtt_ $karnrtt
$tcp6 set add793rto_ $rto
$tcp6 set add793syn_ $syn
$tcp6 set add793expbackoff_ $expbackoff
$tcp6 set add793fastrtx_ $fastrtx
$tcp6 set add793slowstart_ $slowstart
$tcp6 set add793additiveinc_ $additiveinc
$tcp6 set add793exponinc_ $exponinc

$ns at 0.001 "$tcp6 set ssthresh_ 1"

set sink6 [new Agent/TCPSink]
$ns attach-agent $dest $sink6
$ns connect $tcp6 $sink6

set ftp6 [new Application/FTP]
$ftp6 attach-agent $tcp6



set tcp7 [new Agent/TCP/RFC793edu]
$ns attach-agent $s7 $tcp7
$tcp7 set window_ $maxwnd
$tcp7 set rtxcur_init_ $initialtimeout
$tcp7 set add793jacobsonrtt_ $jacobsonrtt
$tcp7 set add793karnrtt_ $karnrtt
$tcp7 set add793rto_ $rto
$tcp7 set add793syn_ $syn
$tcp7 set add793expbackoff_ $expbackoff
$tcp7 set add793fastrtx_ $fastrtx
$tcp7 set add793slowstart_ $slowstart
$tcp7 set add793additiveinc_ $additiveinc
$tcp7 set add793exponinc_ $exponinc

$ns at 0.001 "$tcp7 set ssthresh_ 1"

set sink7 [new Agent/TCPSink]
$ns attach-agent $dest $sink7
$ns connect $tcp7 $sink7

set ftp7 [new Application/FTP]
$ftp7 attach-agent $tcp7



set tcp8 [new Agent/TCP/RFC793edu]
$ns attach-agent $s8 $tcp8
$tcp8 set window_ $maxwnd
$tcp8 set rtxcur_init_ $initialtimeout
$tcp8 set add793jacobsonrtt_ $jacobsonrtt
$tcp8 set add793karnrtt_ $karnrtt
$tcp8 set add793rto_ $rto
$tcp8 set add793syn_ $syn
$tcp8 set add793expbackoff_ $expbackoff
$tcp8 set add793fastrtx_ $fastrtx
$tcp8 set add793slowstart_ $slowstart
$tcp8 set add793additiveinc_ $additiveinc
$tcp8 set add793exponinc_ $exponinc

$ns at 0.001 "$tcp8 set ssthresh_ 1"

set sink8 [new Agent/TCPSink]
$ns attach-agent $dest $sink8
$ns connect $tcp8 $sink8

set ftp8 [new Application/FTP]
$ftp8 attach-agent $tcp8


set tcp9 [new Agent/TCP/RFC793edu]
$ns attach-agent $s9 $tcp9
$tcp9 set window_ $maxwnd
$tcp9 set rtxcur_init_ $initialtimeout
$tcp9 set add793jacobsonrtt_ $jacobsonrtt
$tcp9 set add793karnrtt_ $karnrtt
$tcp9 set add793rto_ $rto
$tcp9 set add793syn_ $syn
$tcp9 set add793expbackoff_ $expbackoff
$tcp9 set add793fastrtx_ $fastrtx
$tcp9 set add793slowstart_ $slowstart
$tcp9 set add793additiveinc_ $additiveinc
$tcp9 set add793exponinc_ $exponinc

$ns at 0.001 "$tcp9 set ssthresh_ 1"

set sink9 [new Agent/TCPSink]
$ns attach-agent $dest $sink9
$ns connect $tcp9 $sink9

set ftp9 [new Application/FTP]
$ftp9 attach-agent $tcp9


set tcp10 [new Agent/TCP/RFC793edu]
$ns attach-agent $s10 $tcp10
$tcp10 set window_ $maxwnd
$tcp10 set rtxcur_init_ $initialtimeout
$tcp10 set add793jacobsonrtt_ $jacobsonrtt
$tcp10 set add793karnrtt_ $karnrtt
$tcp10 set add793rto_ $rto
$tcp10 set add793syn_ $syn
$tcp10 set add793expbackoff_ $expbackoff
$tcp10 set add793fastrtx_ $fastrtx
$tcp10 set add793slowstart_ $slowstart
$tcp10 set add793additiveinc_ $additiveinc
$tcp10 set add793exponinc_ $exponinc

$ns at 0.001 "$tcp10 set ssthresh_ 1"

set sink10 [new Agent/TCPSink]
$ns attach-agent $dest $sink10
$ns connect $tcp10 $sink10

set ftp10 [new Application/FTP]
$ftp10 attach-agent $tcp10



proc finish {} {

    global ns trace_all trace_wnd
    close $trace_all
    close $trace_wnd

    #Following are awk scripts to process trace of all events.

    exec awk {
	{
	    if (($1 == "r") && ($4 == "12"))\
		    print $2, $9, $6
	}
    } out.all > out.rec
	

    exec rm out.all

    exit 0
}


$qE1E2 printPolicyTable
$qE1E2 printPolicerTable
$ns at 0.1 "record"
$ns at 0.0 "$cbr1 start"
$ns at 0.0 "$cbr2 start"
$ns at 0.0 "$ftp3 start"
$ns at 0.0 "$ftp4 start"
$ns at 0.0 "$ftp5 start"
$ns at 0.0 "$ftp6 start"
$ns at 0.0 "$ftp7 start"
$ns at 0.0 "$ftp8 start"
$ns at 0.0 "$ftp9 start"
$ns at 0.0 "$ftp10 start"
$ns at 10.0 "$qE1E2 printStats"
$ns at 20.0 "$qE1E2 printStats"
$ns at 30.0 "$qE1E2 printStats"
$ns at 40.0 "$qE1E2 printStats"
$ns at $testTime "$cbr1 stop"
$ns at $testTime "$cbr2 stop"
$ns at $testTime "$ftp3 stop"
$ns at $testTime "$ftp4 stop"
$ns at $testTime "$ftp5 stop"
$ns at $testTime "$ftp6 stop"
$ns at $testTime "$ftp7 stop"
$ns at $testTime "$ftp8 stop"
$ns at $testTime "$ftp9 stop"
$ns at $testTime "$ftp10 stop"
$ns at [expr $testTime + 1.0] "finish"

$ns run
